#ifndef ABERSIM_CORRECTION_H_
#define ABERSIM_CORRECTION_H_

#include <cufft.h>
#include <fftw3.h>

void abcorrection(	fftw_complex *indata, 
					cufftComplex *result, 
					const int fc_index, 
					const int bandwidth_indexes, 
					const int xsize, 
					const int ysize, 
					const int zsize, 
					const int streams, 
					const int n);

void loadData(	fftw_complex *indata, 
				char *fnstr, 
				char *logstr, 
				const int xsize, 
				const int ysize, 
				const int zsize, 
				char *matrixName);

void saveData(	cufftComplex *result, 
				char *fnstr, 
				char *logstr, 
				const int xsize, 
				const int ysize, 
				const int zsize, 
				const int harmonic, 
				char *realName, 
				char *imagName);

void initializeCuda(int device);

void allocate(	fftw_complex **indata, 
				cufftComplex **result, 
				int xsize, 
				int ysize, 
				int zsize, 
				int streams);

void deAllocate(	fftw_complex *indata, 
					cufftComplex *result);

#endif /*ABERSIM_CORRECTION_H_ */

