#ifndef CONVOLUTION_H_
#define CONVOLUTION_H_

#include <cufft.h>

////////////////////////////////////////////////////////////////////////////////
// KERNEL CONFIGURATION
////////////////////////////////////////////////////////////////////////////////
#define KERNEL_RADIUS 2		// Number of elements on each side to consider
#define KERNEL_RADIUSF 2.0f	// Float version for us in calculations

//TODO REMEMER to change pragma unroll for convolutionS to match KERNEL_W!!!!
//TODO REMEMER to change pragma unroll for convolutionS to match KERNEL_W!!!!
//TODO REMEMER to change pragma unroll for convolutionS to match KERNEL_W!!!!

#define	KERNEL_W (2 * KERNEL_RADIUS + 1)			// Total width of kernel
#define	KERNEL_WF (2.0f * KERNEL_RADIUSF + 1.0f)	// Float version for use in calculations

//TODO REMEMER to change pragma unroll for convolutionS to match BANDWIDTH!!!!
//TODO REMEMER to change pragma unroll for convolutionS to match BANDWIDTH!!!!
//TODO REMEMER to change pragma unroll for convolutionS to match BANDWIDTH!!!!

//#define FCBAND
//#define FC 25 				// Focus center freqency element
//#define BANDWIDTH 14 		// How many elements to average around FC, half on each side. (total of BANDWIDTH+1)
//#define BANDWIDTHF 14.0f 	// Float version for use in calculations

__global__ void convolutionS(	cufftComplex* d_Data, 
								cufftComplex* d_Result, 
 								cufftComplex* d_S,
 								const float mu, 
 								const int xsize, 
 								const int ysize, 
 								const int zsize, 
								const size_t pitch, 
								const int bandwidth, 
								const int fc);

#endif /*CONVOLUTION_H_*/

