#include "gpuFFT.h"

cufftHandle plan;

/*
 * Sets up the CUFFT: creating a plan and assigning the matrices that are to be computed.
 */
void cuda_setupFFT(const int N, const int BATCH) {
	cufftPlan1d(&plan, N, CUFFT_C2C, BATCH);
}

/*
 * Run the FFT calculation.
 */
cufftResult cuda_doFFT(cufftComplex *eM, cufftComplex *rM) {
	return cufftExecC2C(plan, eM, rM, CUFFT_FORWARD);
}

/*
 * Cleanup: Delete the plan.
 */
void cuda_cleanupFFT() {
	cufftDestroy(plan);
}
